/* =====================================
=  Program Name: abundancebin
=  File Name: myHash.h
=  Version: 1.0
=  Developer: Yu-Wei Wu <yuwwu@indiana.edu>, and Yuzhen Ye <yye@indiana.edu>
=  Affiliation: School of Informatics, Indiana University, Bloomington
=
=  abundancebin is free software under the terms of the GNU General Public
=  License as published by the Free Software Foundation.
======================================*/

#ifndef	__MYHASH_H__
#define __MYHASH_H__

#include <iostream>
#include "myMalloc.h"

#ifndef WIN32
	#define _int64 long long
#endif

typedef struct profile_lnk
{
	unsigned int value;
	unsigned int count;
	struct profile_lnk *next;
} profile_lnk;

class myHash
{
	public:
		// Functions
		myHash(int unitSize);
		~myHash();
		void add(unsigned _int64 value);
		void resetIndex();
		profile_lnk* next();
		profile_lnk* find(unsigned _int64 value);
		unsigned int nextCount();
		unsigned int returnHighestCount();
		//unsigned _int64 reportTotalNum();
		unsigned int reportTotalNum();
		unsigned _int64 reportTotalMem();
	private:
		// Variables
		myMalloc *mem_handler;
		int hashSize;
		//_int64 count;
		unsigned int count;
		unsigned int highest_count;
		profile_lnk **profileHead;
		profile_lnk **profileCurrent;
		profile_lnk *profileRecent;
		int currentHash;
};





#endif
