/* =====================================
=  Program Name: abundancebin
=  File Name: myStack.cpp
=  Version: 1.0
=  Developer: Yu-Wei Wu <yuwwu@indiana.edu>, and Yuzhen Ye <yye@indiana.edu>
=  Affiliation: School of Informatics, Indiana University, Bloomington
=
=  abundancebin is free software under the terms of the GNU General Public
=  License as published by the Free Software Foundation.
======================================*/

#include "myStack.h"

const int myStack::maxSize = 1024;

myStack::myStack()
{
	sArray = (unsigned short*)malloc(maxSize * sizeof(unsigned short));
	memset(sArray, '\0', maxSize * sizeof(unsigned short));
	fAbundance = (double*)malloc(maxSize * sizeof(double));
	memset(fAbundance, '\0', maxSize * sizeof(double));
	fSize = (double*)malloc(maxSize * sizeof(double));
	memset(fSize, '\0', maxSize * sizeof(double));
	pos = 0;
}

bool myStack::push(unsigned short b, double inputAbundance, double inputSize)
{
	if (pos >= maxSize)
	{
		return false;
	}
	sArray[pos] = b;
	fAbundance[pos] = inputAbundance;
	fSize[pos] = inputSize;
	pos++;
	return true;
}

void myStack::pop(unsigned short *b, double *inputAbundance, double *inputSize)
{
	if (pos <= 0)
	{
		*b = 0;
		*inputAbundance = 0;
		*inputSize = 0;
	}
	pos--;
	*b = sArray[pos];
	*inputAbundance = fAbundance[pos];
	*inputSize = fSize[pos];
}

bool myStack::isContent()
{
	if (pos == 0)
	{
		return false;
	}
	else
	{
		return true;
	}
}
