/* =====================================
=  Program Name: abundancebin
=  File Name: myStringHash.h
=  Version: 1.0
=  Developer: Yu-Wei Wu <yuwwu@indiana.edu>, and Yuzhen Ye <yye@indiana.edu>
=  Affiliation: School of Informatics, Indiana University, Bloomington
=
=  abundancebin is free software under the terms of the GNU General Public
=  License as published by the Free Software Foundation.
======================================*/

#ifndef	__MYSTRINGHASH_H__
#define __MYSTRINGHASH_H__

#include <iostream>
#include "myMalloc.h"

typedef struct strhash_lnk
{
	char *ref;
	short dest;
	struct strhash_lnk *next;
} strhash_lnk;

class myStringHash
{
	public:
		// Functions
		myStringHash();
		myStringHash(int unitSize);
		~myStringHash();
		void add(char *str, short destination);
		void resetIndex();
		//strhash_lnk* next();
		short find(char *str);
		//unsigned int nextCount();
		//unsigned int returnHighestCount();
		//unsigned _int64 reportTotalNum();
		//unsigned int reportTotalNum();
		//unsigned _int64 reportTotalMem();
	private:
		// Variables
		myMalloc *mem_handler;
		int hashSize;
		//_int64 count;
		//unsigned int count;
		//unsigned int highest_count;
		strhash_lnk **hashHead;
		strhash_lnk **hashCurrent;
		strhash_lnk *hashRecent;
		int currentHash;
		int getEncode(char *str);
};





#endif
